SystemOrganization addCategory: #LightControlling!

Object subclass: #LightController
	instanceVariableNames: 'mcController'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LightControlling'!

!LightController methodsFor: 'versionLoading' stamp: 'rkrk 2/4/2008 01:02'!
defaultRepository

	^ MCHttpRepository
		location: 'http://www.swa.hpi.uni-potsdam.de/squeaksource/SVNDiffBrowser'
		user: 'rkrk'
		password: 'squeakIsFun123'! !

!LightController methodsFor: 'versionLoading' stamp: 'rkrk 2/4/2008 01:02'!
defaultVersionName

	^  'SqueakSVN-rkrk.19'! !

!LightController methodsFor: 'lights' stamp: 'rkrk 2/4/2008 01:06'!
greenLightSocketTo: socketState

	self
		switchSocket: 3
		to: socketState.! !

!LightController methodsFor: 'initialize-release' stamp: 'rkrk 2/4/2008 01:02'!
initialize

	mcController := MCController
		forRepository: self defaultRepository
		withOlderVersionName: self defaultVersionName! !

!LightController methodsFor: 'lights' stamp: 'rkrk 2/4/2008 01:06'!
redLightSocketTo: socketState

	self
		switchSocket: 1
		to: socketState.! !

!LightController methodsFor: 'test running' stamp: 'rkrk 2/4/2008 01:25'!
runTestsAndSetLights

	| result |
	result := TestReporter new runCategories: 'SqueakSVN-Test'.
	result errors ifNotEmpty: [self redLightSocketTo: #on. ^ self].
	result defects ifNotEmpty: [self yellowLightSocketTo: #on. ^ self].
	self greenLightSocketTo: #on.! !

!LightController methodsFor: 'lights' stamp: 'rkrk 2/4/2008 01:09'!
switchSocket: socketNumber to: socketState

	| pathOfPowerMgr command p |
	pathOfPowerMgr := 'C:\temp\PM\powermanager\'.
	command := pathOfPowerMgr , 'pm2.exe -' , socketState asString , '-Device1 -Socket' , socketNumber asString.
	p := ExternalOSProcess command: command.
	[p isComplete] whileFalse: [(Delay forMilliseconds: 20) wait].! !

!LightController methodsFor: 'lights' stamp: 'rkrk 2/4/2008 01:05'!
turnLightsOff

	self
		redLightSocketTo: #off;
		yellowLightSocketTo: #off;	
		greenLightSocketTo: #off.! !

!LightController methodsFor: 'lights' stamp: 'rkrk 2/4/2008 01:06'!
yellowLightSocketTo: socketState

	self
		switchSocket: 2
		to: socketState.! !

Object subclass: #MCController
	instanceVariableNames: 'repository anOlderVersionName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LightControlling'!

!MCController class methodsFor: 'instance creation' stamp: 'rkrk 2/4/2008 00:52'!
forRepository: aMCRepository 
	
	^ self new
		repository: aMCRepository;
		yourself.! !

!MCController class methodsFor: 'instance creation' stamp: 'rkrk 2/4/2008 00:58'!
forRepository: aMCRepository withOlderVersionName: aString
	
	^ self repository: aMCRepository;
		anOlderVersionName: aString
		yourself.! !

!MCController methodsFor: 'accessing' stamp: 'rkrk 2/4/2008 00:58'!
anOlderVersionName
	
	^ anOlderVersionName! !

!MCController methodsFor: 'accessing' stamp: 'rkrk 2/4/2008 00:58'!
anOlderVersionName: aString

	anOlderVersionName := aString ! !

!MCController methodsFor: 'finding' stamp: 'rkrk 2/4/2008 00:24'!
findNameOfNewesVersionOf: aCollection 
	
	| biggestVersionNumber eachVersionNumber |
	self assert: aCollection isEmpty not.
	^ aCollection inject: aCollection first into: [:biggestVersion :each |
			biggestVersionNumber := (biggestVersion subStrings: '.') last asNumber.
			eachVersionNumber := (each subStrings: '.') last asNumber.
			biggestVersionNumber < eachVersionNumber
				ifTrue: [each]
				ifFalse: [biggestVersion]].! !

!MCController methodsFor: 'accessing' stamp: 'rkrk 2/4/2008 00:57'!
loadNewestVersion

	| newestVersion |
	newestVersion := self findNameOfNewesVersionOf: self anOlderVersionName.
	(self versionNamed: newestVersion , '.mcz') load.! !

!MCController methodsFor: 'accessing' stamp: 'rkrk 2/4/2008 00:53'!
repository
	
	^ repository! !

!MCController methodsFor: 'accessing' stamp: 'rkrk 2/4/2008 00:53'!
repository: aMCRepository 
	
	repository := aMCRepository! !

!MCController methodsFor: 'accessing' stamp: 'rkrk 2/4/2008 00:54'!
versionNamed: aString 
	
	^ self repository versionFromFileNamed: aString.! !

TestCase subclass: #LightControllerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LightControlling'!

TestCase subclass: #MCControllerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LightControlling'!

!MCControllerTest methodsFor: 'tests' stamp: 'rkrk 2/4/2008 00:10'!
testFindNewesVersionName

	| versionNames versionNameFound sut |
	versionNames := #('SqueakSVN-rkrk.18' 'SqueakSVN-rkrk.19' 'SqueakSVN-rkrk.17' ).
	sut := MCController new.
	versionNameFound := sut findNameOfNewesVersionOf: versionNames.
	self assert: versionNameFound = 'SqueakSVN-rkrk.19'.! !

!MCControllerTest methodsFor: 'tests' stamp: 'rkrk 2/4/2008 00:51'!
testLoadVersionFile

	| repository sut result |
	repository := MCHttpRepository
		location: 'http://www.swa.hpi.uni-potsdam.de/squeaksource/SVNDiffBrowser'
		user: 'rkrk' password: 'squeakIsFun123'.
	sut := MCController forRepository: repository.
	result := sut versionNamed: 'SqueakSVN-rkrk.19.mcz'.
	self assert: result info name =  'SqueakSVN-rkrk.19'! !
